% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % ----------------------------------------------------------------% % %
%                Script that plot results from Error.m                    %
% % % ----------------------------------------------------------------% % %
%                  Important to run that file first!                      %
% % % ----------------------------------------------------------------% % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

close all

%% Define colors
Orange      = [0.94 0.47 0] ;
Purple      = [0.25 0 0.5];
Brown       = [0.5 0.25 0];
DarkGreen   = [0 0.25 0];
Gray        = [0.5 0.5 0.5];
LightPurple = [0.5 0.5 1];
Turquoise   = [0 0.5 0.5];
Burgundy    = [0.5 0 0];
Peach       = [1 0.5 0.5];
LightRed    = [1 0.7 0.5];
LightBlue   = [0 0.6 1];

%% Set up figures
%set(figure(1), 'Position', [x y width height])
set(figure(1), 'Position', [50 50 800 1000])
set(figure(2), 'Position', [770 600 700 260])
set(figure(4), 'Position', [770 50 700 260])
set(figure(5), 'Position', [-770 600 700 450])
set(figure(6), 'Position', [-1500 600 700 450])
% set(figure(7), 'Position', [-770 50 700 450])
% set(figure(8), 'Position', [-1500 50 700 450])
set(figure(9), 'Position', [-1300 50 700 450])
% set(figure(10), 'Position', [-1100 50 700 450])
set(figure(11), 'Position', [-1000 50 700 450])

%% Time shift measured raw force and filtered force to match each other
[F_1_raw] = Sampling_Force(FC_1N_new(:,3),FC_1N_F(:,3))
[F_5_raw] = Sampling_Force(FC_5N_new(:,3),FC_5N_F(:,3))
[F_10_raw] = Sampling_Force(FC_10N_new(:,3),FC_10N_F(:,3))
[F_25_raw] = Sampling_Force(FC_25N_new(:,3),FC_25N_F(:,3))
[F_50_filt] = Sampling_Force(FC_50N_F(:,3),FC_50N_new(:,2))


%% Chosen data sets from the FC procedure
e1 = (1295:1380);
e2 = (834:1380);
e3 = (769:1380);
e4 = (746:1380);
e5 = (738:1380);
% 
% ef1 = (1016:1101);
% ef2 = (692:1238);
% ef3 = (617:1228);
% ef4 = (628:1262);
% ef5 = (127:769);


o1 = (495:1480);
o2 = (434:1480);
o3 = (269:1480);
o4 = (246:1480);
o5 = (612:1480);

f1 = (216:1201);
f2 = (292:1338);
f3 = (117:1328);
f4 = (128:1362);
f5 = (1:869);


%% Figure 1
figure(1)
subplot(511)
plot(o7_1(o1,1),F_1_raw(f1),'g')
hold on
plot(o7_1(o1,1),FC_1N_F(f1,3),'b')
plot([0 2],[1 1],'--k')
xlim([o7_1(o1(1),1) o7_1(o1(end),1)])
ylim([-30 40])
grid on
ylabel('Force [N]')
xlabel('x [m]')
legend('1 N raw','1 N filtered')

subplot(512)
plot(o7_2(o2,1),F_5_raw(f2),'g')
hold on
plot(o7_2(o2,1),FC_5N_F(f2,3),'b')
plot([0 2],[5 5],'--k')
xlim([o7_2(o2(1),1) o7_2(o2(end),1)])
ylim([-30 40])
grid on
ylabel('Force [N]')
xlabel('x [m]')
legend('5 N raw','5 N filtered')

subplot(513)
[f0,f_,power0,power,xf] = fft_fun(1/0.004032,F_10_raw(f3),1,17); % fft on signal
plot(o7_3(o3,1),F_10_raw(f3),'g')
hold on
% plot(o7_3(o3,1),FC_10N_F(f3,3),'b')
plot(o7_3(o3,1),xf,'b')
plot([0 2],[10 10],'--k')
xlim([o7_3(o3(1),1) o7_3(o3(end),1)])
ylim([-30 40])
grid on
ylabel('Force [N]')
xlabel('x [m]')
legend('10 N raw','10 N filtered')

subplot(514)
plot(o7_4(o4,1),F_25_raw(f4),'g')
hold on
plot(o7_4(o4,1),FC_25N_F(f4,3),'b')
plot([0 2],[25 25],'--k')
xlim([o7_4(o4(1),1) o7_4(o4(end),1)])
ylim([-30 80])
grid on
ylabel('Force [N]')
xlabel('x [m]')
legend('25 N raw','25 N filtered')

subplot(515)
plot(o7_5(o5,1),FC_50N_new(f5,2),'g')
hold on
plot(o7_5(o5,1),F_50_filt(f5),'b')
plot([0 2],[50 50],'--k')
xlim([o7_5(o5(1),1) o7_5(o5(end),1)])
grid on
ylabel('Force [N]')
xlabel('x [m]')
legend('50 N raw','50 N filtered')
ylim([-30 80])

%% Figure 2
figure(2)
plot(o7_1(504:1480,1),o7_1(504:1480,3),'b')
hold on
plot(o7_2(500:1477,1),o7_2(500:1477,3),'r')
plot(o7_3(500:1500,1),o7_3(500:1500,3),'g')
plot(o7_4(504:1482,1),o7_4(504:1482,3),'k')
plot(o7_5(504:1482,1),o7_5(504:1482,3),'m')
legend('1 N','5 N','10 N','25 N','50 N')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('Length x axis [m]')
ylabel('Length z axis [m]')

%% Figure 4
figure(4)
plot(Cam_Ext_1(600:1500,1),Cam_Ext_1(600:1500,3),'b')
hold on
plot(Cam_Ext_2(600:1500,1),Cam_Ext_2(600:1500,3),'r')
plot(Cam_Ext_3(600:1500,1),Cam_Ext_3(600:1500,3),'g')
plot(Cam_Ext_4(600:1500,1),Cam_Ext_4(600:1500,3),'k')
plot(Cam_Ext_5(600:1500,1),Cam_Ext_5(600:1500,3),'m')
legend('1 N','5 N','10 N','25 N','50 N')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('Length x axis [m]')
ylabel('Length z axis [m]')

%% Figure 5
figure(5)
subplot(2,2,1)
plot(Cam_Ext_2(600:1400,1),Cam_Ext_2(600:1400,3))
hold on
plot(o7_2(600:1400,1),o7_2(600:1400,3),'r')
legend('Camera','Robot','orientation','horizontal')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('x [m]')
ylabel('z [m]')
title('Force = 5 Newton')
subplot(2,2,2)
plot(Cam_Ext_3(600:1400,1),Cam_Ext_3(600:1400,3))
hold on
plot(o7_3(600:1400,1),o7_3(600:1400,3),'r')
legend('Camera','Robot','orientation','horizontal')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('x [m]')
ylabel('z [m]')
title('Force = 10 Newton')
subplot(2,2,3)
plot(Cam_Ext_4(600:1400,1),Cam_Ext_4(600:1400,3))
hold on
plot(o7_4(600:1400,1),o7_4(600:1400,3),'r')
legend('Camera','Robot','orientation','horizontal')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('x [m]')
ylabel('z [m]')
title('Force = 25 Newton')
subplot(2,2,4)
plot(Cam_Ext_5(600:1400,1),Cam_Ext_5(600:1400,3))
hold on
plot(o7_5(600:1400,1),o7_5(600:1400,3),'r')
legend('Camera','Robot','orientation','horizontal')
ylim([0.1675 0.172])
xlim([0.945 1.09])
xlabel('x [m]')
ylabel('z [m]')
title('Force = 50 Newton')

%% Figure 6
figure(6)
plot(o7_1(600:1400,1),Error_1(600:1400,3),'b')
hold on
plot(o7_2(600:1400,1),Error_2(600:1400,3),'r')
plot(o7_3(600:1400,1),Error_3(600:1400,3),'g')
plot(o7_4(600:1400,1),Error_4(600:1400,3),'k')
plot(o7_5(600:1400,1),Error_5(600:1400,3),'m')
ylim([-3 4].*1e-4)
xlim([0.945 1.09])
xlabel('x [m]')
ylabel('z [m]')
legend('1 N','5 N','10 N','25 N','50 N')

%% Figure 9
figure(9)
subplot(3,1,1)
plot(o7_1(600:1400,1),Error_1(600:1400,1),'b')
hold on
plot(o7_2(600:1400,1),Error_2(600:1400,1),'r')
plot(o7_3(600:1400,1),Error_3(600:1400,1),'g')
plot(o7_4(600:1400,1),Error_4(600:1400,1),'k')
ylim([-2 8].*1e-4)
xlim([0.945 1.09])
ylabel('Length x axis [m]')
% title('Comparing deviation of forces')
legend('1 N','10 N','25 N','50 N')
subplot(3,1,2)
plot(o7_1(600:1400,1),Error_1(600:1400,2),'b')
hold on
plot(o7_2(600:1400,1),Error_2(600:1400,2),'r')
plot(o7_3(600:1400,1),Error_3(600:1400,2),'g')
plot(o7_4(600:1400,1),Error_4(600:1400,2),'k')
ylabel('Length y axis [m]')
ylim([-5 5].*1e-4)
xlim([0.945 1.09])
subplot(3,1,3)
plot(o7_1(600:1400,1),Error_1(600:1400,3),'b')
hold on
plot(o7_2(600:1400,1),Error_2(600:1400,3),'r')
plot(o7_3(600:1400,1),Error_3(600:1400,3),'g')
plot(o7_4(600:1400,1),Error_4(600:1400,3),'k')
xlabel('Length x axis [m]')
ylabel('Length z axis [m]')
ylim([-3 6].*1e-4)
xlim([0.945 1.09])
ylabel('Force [N]')
xlabel('z axis [m]')
legend('1 N','10 N','25 N','50 N','f(x)')


%% Changing indices to fit such that all forces have contact
e1 = (1295:1380);
e2 = (1295:1380); % (1234:1380);
e3 = (1295:1380); % (1269:1380);
e4 = (1295:1380); % (1246:1380);
e5 = (1295:1380); % (1238:1380);
% 
ef1 = (1016:1101);
ef2 = (1153:1238); % (1092:1238);
ef3 = (1143:1228); % (1117:1228);
ef4 = (1177:1262); % (1128:1262);
ef5 = (684:769); % (627:769);

%% Figure 11
figure(11) % shift added for z
shift_z = 0;
Process_1_F = FC_1N_F(ef1,3);
o7_1N = Error_1(e1,3) + shift_z;
Process_5_F = FC_5N_F(ef2,3);
o7_5N = Error_2(e2,3) + shift_z;
Process_10_F = FC_10N_F(ef3,3);
o7_10 = Error_3(e3,3) + shift_z;
Process_25_F = FC_25N_F(ef4,3);
o7_25 = Error_4(e4,3) + shift_z;
Process_50_F = FC_50N_F(ef5,3);
o7_50 = Error_5(e5,3) + shift_z;

t = 0:1e-5:4e-4;

np2 = polyfit([0 o7_50(8)],[0 50],1)
nf2 = @(x)np2(1)*x;
nf2max = @(x)np2(1)*x + 3.5;
nf2min = @(x)np2(1)*x - 3.5;
nt2 = nf2(t);
nt2max = nf2max(t);
nt2min = nf2min(t);

hold on
plot(o7_1N,FC_1N_F(ef1,3),'b*')
hold on
plot(o7_5N,FC_5N_F(ef2,3),'r*')
plot(o7_10,FC_10N_F(ef3,3),'g*')
plot(o7_25,FC_25N_F(ef4,3),'k*')
plot(o7_50,F_50_filt(ef5),'m*')
plot(t,nt2,'--k')
lol = fill([t t(40) t(33) fliplr(t)],[nt2min nt2min(40) nt2max(33) fliplr(nt2max)],[0.9 0.9 0.9])
set(lol,'FaceColor','b','EdgeColor','w','facealpha',0.07)

grid on
box on
xlim([0 4.5].*1e-4)
ylim([0 60])

text(2.1e-4,23,'\fontsize{10}h(Force) = 2.1861*10^5e + \sigma')
ylabel('Force [N]')
xlabel('Deviation of camera vs. robot in z axis [m]')
legend('1 N','5 N','10 N','25 N','50 N','h(Force)')






