% Time shift measured raw force and filtered force to match each other

function [F_shifted] = Sampling_Force(F,F_filtered)

% h_rob = 0.008064;   % Sampling time encoders
h_cam = 0.01;       % Sampling time camera system
h_force = 0.000504;
%% xCorr

[c,lags] = xcorr(F,F_filtered); % Find x-correlation

[~,I] = max(abs(c));    % Find max deviation
LagSamples = lags(I);   % Index of xcorr for the maximum value
% TimeShift = LagSamples*h_cam; % Shift in seconds
if LagSamples < 0
    F_shift = F(-LagSamples:end,:); % Shift applied for x y z
elseif LagSamples == 0
    F_shift = F(1:end,:)
else
    F_shift = F(LagSamples:end,:); % Shift applied for x y z
end

F_shifted = F_shift(1:1400,:); % Cutting vector for matching