% The function are given two signals and sampling time of the fastest
% signal. The output provide signals of same sampling time and fit the
% signals with respect to eachother.


function [signal_2_new, signal_1_new] = Sampling_Rob(signal_1, signal_2, sampl)

h_cam = 0.01;       % Sampling time camera system

signal_1_new = interp1(1:length(signal_1),signal_1,1:h_cam/sampl:length(signal_1),'spline');
signal_2_new = signal_2'./1000;

[c,lags] = xcorr(signal_2_new(:,1),signal_1_new(:,1)); % Find x-correlation

[~,I] = max(abs(c));    % Find max deviation
LagSamples = lags(I);   % Index of xcorr for the maximum value
% TimeShift = LagSamples*sampl; % Shift in seconds

signal_1_shift = signal_1_new(-LagSamples:end,:); % Shift applied for x y z
t = (0:length(signal_2_new)-1)*sampl;

signal_1_new = signal_1_shift(1:length(signal_2_new),:); % Cutting vector for matching