% Calculations of PSD, and possibly adding filter if i == 1. if i == 0 no
% filter is applied, only PSD. 
% fs is sampling frequency. 
% Signal is chosen signal to view.
% fc is cutt-off frequencyif filter is chosen.

function [f0,f,power0,power,xf] = fft_fun(fs,Signal,i,fc)

if i == 1 % Filter the signal
    fn = fs/2; % Nyquist Frequency 
    [b,a] = butter(5,fc/fn); % IIR Filter coefficients, b=num, a=denom 
    xf = filtfilt(b,a,Signal); % apply filter to x
else 
    xf = Signal;
end

m = length(xf);     % Window length
n = pow2(nextpow2(m));  % Transform length
y = fft(xf,n);      % DFT
f = (0:n-1)*(fs/n);     % Frequency range
power = y.*conj(y)/n;   % Power of the DFT

y0 = fftshift(y);          % Rearrange y values
f0 = (-n/2:n/2-1)*(fs/n);  % 0-centered frequency range
power0 = y0.*conj(y0)/n;   % 0-centered power
