function o7 = ForwKinematics(q)
% Input example: q = [0 0 0 0 0 0];

%% Dimensions IRB 4600
Parameters

%% Defining qi
q1 = q(1);
q2 = q(2);
q3 = q(3);
q4 = q(4);
q5 = q(5);
q6 = q(6);

%% Coordinate frame origins
o0 = [0 0 0];
o1 = [a1 * cos(q1) a1 * sin(q1) d1];
o2 = [cos(q1) * a2 * cos(-q2 + pi / 0.2e1) + sin(q1) * cos(pi / 0.2e1) * a2 * sin(-q2 + pi / 0.2e1) + a1 * cos(q1) sin(q1) * a2 * cos(-q2 + pi / 0.2e1) - cos(q1) * cos(pi / 0.2e1) * a2 * sin(-q2 + pi / 0.2e1) + a1 * sin(q1) sin(pi / 0.2e1) * a2 * sin(-q2 + pi / 0.2e1) + d1];
o3 = [(-sin(q1) * sin(q3) * cos(pi / 0.2e1) * a3 + cos(q1) * (a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (sin(q1) * (a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q3) * a3 * cos(q1)) * sin(-q2 + pi / 0.2e1) + a1 * cos(q1) (sin(q3) * cos(pi / 0.2e1) * a3 * cos(q1) + sin(q1) * (a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (-cos(q1) * (a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q1) * sin(q3) * a3) * sin(-q2 + pi / 0.2e1) + a1 * sin(q1) sin(pi / 0.2e1) * (a3 * cos(q3) + a2) * sin(-q2 + pi / 0.2e1) - sin(pi / 0.2e1) * cos(-q2 + pi / 0.2e1) * a3 * sin(q3) + d1];
o4 = [(-sin(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3)) * cos(pi / 0.2e1) + cos(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (sin(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * cos(pi / 0.2e1) + cos(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3))) * sin(-q2 + pi / 0.2e1) - sin(q1) * cos(pi / 0.2e1) * sin(pi / 0.2e1) * d4 + a1 * cos(q1) (cos(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3)) * cos(pi / 0.2e1) + sin(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (-cos(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3))) * sin(-q2 + pi / 0.2e1) + cos(q1) * cos(pi / 0.2e1) * sin(pi / 0.2e1) * d4 + a1 * sin(q1) sin(pi / 0.2e1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * sin(-q2 + pi / 0.2e1) + (-sin(pi / 0.2e1) ^ 2 * d4 * cos(q3) - a3 * sin(q3) * sin(pi / 0.2e1)) * cos(-q2 + pi / 0.2e1) + cos(pi / 0.2e1) ^ 2 * d4 + d1];
o5 = [(-sin(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3)) * cos(pi / 0.2e1) + cos(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (sin(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * cos(pi / 0.2e1) + cos(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3))) * sin(-q2 + pi / 0.2e1) - sin(q1) * cos(pi / 0.2e1) * sin(pi / 0.2e1) * d4 + a1 * cos(q1) (cos(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3)) * cos(pi / 0.2e1) + sin(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (-cos(q1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q1) * (cos(q3) * sin(pi / 0.2e1) * d4 + a3 * sin(q3))) * sin(-q2 + pi / 0.2e1) + cos(q1) * cos(pi / 0.2e1) * sin(pi / 0.2e1) * d4 + a1 * sin(q1) sin(pi / 0.2e1) * (-d4 * sin(q3) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * sin(-q2 + pi / 0.2e1) + (-sin(pi / 0.2e1) ^ 2 * d4 * cos(q3) - a3 * sin(q3) * sin(pi / 0.2e1)) * cos(-q2 + pi / 0.2e1) + cos(pi / 0.2e1) ^ 2 * d4 + d1];
o6 = [(cos(q5 + pi) * d6 * (cos(q3) * sin(q1) * cos(pi / 0.2e1) + cos(q1) * sin(q3)) * sin(pi / 0.2e1) ^ 3 + (cos(q3) * sin(q1) * d6 * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 3 + d6 * (sin(q3) * (cos(q1) * cos(q4) - sin(q4) * sin(q1)) * cos(q5 + pi) - sin(q1) * sin(q4) * sin(q5 + pi) * cos(q3) + (-sin(q4) * sin(q1) + cos(q1) * (cos(q4) - 0.1e1)) * sin(q3)) * cos(pi / 0.2e1) ^ 2 + (cos(q1) * cos(q3) * sin(q4) * cos(q5 + pi) * d6 - sin(q3) * d6 * (sin(q4) * cos(q1) + cos(q4) * sin(q1)) * sin(q5 + pi) + cos(q3) * (cos(q1) * sin(q4) * d6 - d4 * sin(q1))) * cos(pi / 0.2e1) + cos(q1) * (sin(q5 + pi) * cos(q3) * cos(q4) * d6 - d4 * sin(q3))) * sin(pi / 0.2e1) - sin(q1) * sin(q3) * cos(pi / 0.2e1) * a3 + cos(q1) * (a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (-cos(q5 + pi) * d6 * (-sin(q1) * sin(q3) * cos(pi / 0.2e1) + cos(q1) * cos(q3)) * sin(pi / 0.2e1) ^ 3 + (sin(q1) * sin(q3) * d6 * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 3 - d6 * (cos(q3) * (cos(q1) * cos(q4) - sin(q4) * sin(q1)) * cos(q5 + pi) + sin(q1) * sin(q3) * sin(q4) * sin(q5 + pi) + cos(q3) * (-sin(q4) * sin(q1) + cos(q1) * (cos(q4) - 0.1e1))) * cos(pi / 0.2e1) ^ 2 + (cos(q1) * sin(q3) * sin(q4) * d6 * cos(q5 + pi) + d6 * cos(q3) * (sin(q4) * cos(q1) + cos(q4) * sin(q1)) * sin(q5 + pi) + sin(q3) * (cos(q1) * sin(q4) * d6 - d4 * sin(q1))) * cos(pi / 0.2e1) + cos(q1) * (cos(q4) * sin(q3) * sin(q5 + pi) * d6 + cos(q3) * d4)) * sin(pi / 0.2e1) + sin(q1) * (a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q3) * a3 * cos(q1)) * sin(-q2 + pi / 0.2e1) - d6 * (((cos(q4) - 0.1e1) * cos(q5 + pi) + cos(q4)) * cos(pi / 0.2e1) - sin(q5 + pi) * sin(q4)) * sin(q1) * sin(pi / 0.2e1) ^ 3 - sin(q1) * cos(pi / 0.2e1) * (cos(pi / 0.2e1) ^ 2 * d6 + d4) * sin(pi / 0.2e1) + a1 * cos(q1) (-cos(q5 + pi) * d6 * (cos(q1) * cos(q3) * cos(pi / 0.2e1) - sin(q1) * sin(q3)) * sin(pi / 0.2e1) ^ 3 + (-cos(q1) * cos(q3) * d6 * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 3 + d6 * (sin(q3) * (sin(q4) * cos(q1) + cos(q4) * sin(q1)) * cos(q5 + pi) + sin(q4) * sin(q5 + pi) * cos(q1) * cos(q3) + (sin(q4) * cos(q1) + sin(q1) * (cos(q4) - 0.1e1)) * sin(q3)) * cos(pi / 0.2e1) ^ 2 + (cos(q3) * sin(q1) * sin(q4) * d6 * cos(q5 + pi) + sin(q3) * d6 * (cos(q1) * cos(q4) - sin(q4) * sin(q1)) * sin(q5 + pi) + cos(q3) * (sin(q1) * sin(q4) * d6 + cos(q1) * d4)) * cos(pi / 0.2e1) + sin(q1) * (sin(q5 + pi) * cos(q3) * cos(q4) * d6 - d4 * sin(q3))) * sin(pi / 0.2e1) + sin(q3) * cos(pi / 0.2e1) * a3 * cos(q1) + sin(q1) * (a3 * cos(q3) + a2)) * cos(-q2 + pi / 0.2e1) + (-cos(q5 + pi) * d6 * (cos(q1) * sin(q3) * cos(pi / 0.2e1) + cos(q3) * sin(q1)) * sin(pi / 0.2e1) ^ 3 + (-cos(q1) * sin(q3) * d6 * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 3 - d6 * (cos(q3) * (sin(q4) * cos(q1) + cos(q4) * sin(q1)) * cos(q5 + pi) - sin(q3) * sin(q4) * sin(q5 + pi) * cos(q1) + (sin(q4) * cos(q1) + sin(q1) * (cos(q4) - 0.1e1)) * cos(q3)) * cos(pi / 0.2e1) ^ 2 + (sin(q1) * sin(q3) * sin(q4) * d6 * cos(q5 + pi) - d6 * cos(q3) * (cos(q1) * cos(q4) - sin(q4) * sin(q1)) * sin(q5 + pi) + sin(q3) * (sin(q1) * sin(q4) * d6 + cos(q1) * d4)) * cos(pi / 0.2e1) + sin(q1) * (cos(q4) * sin(q3) * sin(q5 + pi) * d6 + cos(q3) * d4)) * sin(pi / 0.2e1) - cos(q1) * (a3 * cos(q3) + a2) * cos(pi / 0.2e1) + sin(q1) * sin(q3) * a3) * sin(-q2 + pi / 0.2e1) + d6 * cos(q1) * (((cos(q4) - 0.1e1) * cos(q5 + pi) + cos(q4)) * cos(pi / 0.2e1) - sin(q5 + pi) * sin(q4)) * sin(pi / 0.2e1) ^ 3 + cos(q1) * cos(pi / 0.2e1) * (cos(pi / 0.2e1) ^ 2 * d6 + d4) * sin(pi / 0.2e1) + a1 * sin(q1) (d6 * sin(q3) * cos(q5 + pi) * sin(pi / 0.2e1) ^ 3 + (d6 * sin(q3) * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 2 + sin(q4) * d6 * (cos(q5 + pi) * cos(q3) - sin(q5 + pi) * sin(q3) + cos(q3)) * cos(pi / 0.2e1) + sin(q5 + pi) * cos(q3) * cos(q4) * d6 - d4 * sin(q3)) * sin(pi / 0.2e1) + a3 * cos(q3) + a2) * sin(pi / 0.2e1) * sin(-q2 + pi / 0.2e1) + (d6 * cos(q3) * cos(q5 + pi) * sin(pi / 0.2e1) ^ 3 + (d6 * cos(q3) * (cos(q5 + pi) * cos(q4) + cos(q4) - 0.1e1) * cos(pi / 0.2e1) ^ 2 - sin(q4) * d6 * (cos(q5 + pi) * sin(q3) + sin(q5 + pi) * cos(q3) + sin(q3)) * cos(pi / 0.2e1) - cos(q4) * sin(q3) * sin(q5 + pi) * d6 - cos(q3) * d4) * sin(pi / 0.2e1) - a3 * sin(q3)) * sin(pi / 0.2e1) * cos(-q2 + pi / 0.2e1) + d6 * (((cos(q4) - 0.1e1) * cos(q5 + pi) + cos(q4)) * cos(pi / 0.2e1) - sin(q5 + pi) * sin(q4)) * cos(pi / 0.2e1) * sin(pi / 0.2e1) ^ 2 + d6 * cos(pi / 0.2e1) ^ 4 + cos(pi / 0.2e1) ^ 2 * d4 + d1];
o7 = [-0.960e0 * cos(q(1)) * sin(q(2)) * sin(q(3)) + 0.175e0 * cos(q(1)) * sin(q(2)) * cos(q(3)) + 0.960e0 * cos(q(1)) * cos(q(2)) * cos(q(3)) + 0.175e0 * cos(q(1)) * cos(q(2)) * sin(q(3)) - 0.135e0 * cos(q(1)) * sin(q(2)) * cos(q(3)) * sin(q(5)) * cos(q(4)) + sin(q(1)) * cos(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(4)) * yt + sin(q(1)) * cos(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(4)) * zt + sin(q(5)) * sin(q(6)) * sin(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * xt - sin(q(5)) * sin(q(6)) * sin(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * xt + cos(q(6)) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * xt + cos(q(6)) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * xt - sin(q(5)) * cos(q(4)) * cos(qt2) * cos(q(3)) * sin(q(2)) * cos(q(1)) * zt - sin(q(5)) * cos(q(4)) * cos(qt2) * sin(q(3)) * cos(q(2)) * cos(q(1)) * zt + sin(q(5)) * cos(q(4)) * sin(qt2) * cos(q(3)) * sin(q(2)) * cos(q(1)) * yt + sin(q(5)) * cos(q(4)) * sin(qt2) * sin(q(3)) * cos(q(2)) * cos(q(1)) * yt + sin(q(1)) * cos(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(4)) * yt + sin(q(1)) * cos(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(4)) * zt - sin(q(5)) * cos(q(6)) * cos(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * xt + sin(q(5)) * cos(q(6)) * cos(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * xt + sin(q(6)) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * xt + sin(q(6)) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * xt - 0.135e0 * cos(q(1)) * cos(q(2)) * sin(q(3)) * sin(q(5)) * cos(q(4)) - 0.135e0 * sin(q(5)) * sin(q(4)) * sin(q(1)) - 0.135e0 * cos(q(1)) * sin(q(2)) * sin(q(3)) * cos(q(5)) + 0.135e0 * cos(q(1)) * cos(q(2)) * cos(q(3)) * cos(q(5)) + 0.900e0 * cos(q(1)) * sin(q(2)) + 0.175e0 * cos(q(1)) - sin(q(1)) * cos(q(4)) * sin(q(6)) * cos(qt1) * xt - sin(q(1)) * cos(q(4)) * cos(q(6)) * sin(qt1) * xt - sin(q(1)) * sin(q(5)) * cos(qt2) * sin(q(4)) * zt + sin(q(1)) * sin(q(5)) * sin(qt2) * sin(q(4)) * yt + cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * yt + cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * zt + cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * zt + cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * yt + cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * yt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * zt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * zt + cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * yt - sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * yt + sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * zt - sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * zt - cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * xt - cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * xt - sin(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * yt - sin(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * yt - sin(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * zt - sin(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * zt + sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * yt - sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * yt + sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * zt - sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * cos(q(1)) * zt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * xt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * xt + cos(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * yt + cos(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * yt + cos(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * cos(q(1)) * sin(q(4)) * zt + cos(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * cos(q(1)) * sin(q(4)) * zt + sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * cos(q(1)) * yt - sin(q(1)) * cos(q(5)) * cos(q(6)) * cos(qt1) * sin(q(4)) * xt + sin(q(1)) * cos(q(4)) * sin(q(6)) * cos(qt2) * sin(qt1) * yt + sin(q(1)) * cos(q(4)) * sin(q(6)) * sin(qt2) * sin(qt1) * zt + sin(q(1)) * cos(q(5)) * sin(q(6)) * sin(qt1) * sin(q(4)) * xt - sin(q(1)) * cos(q(4)) * cos(q(6)) * cos(qt2) * cos(qt1) * yt - sin(q(1)) * cos(q(4)) * cos(q(6)) * sin(qt2) * cos(qt1) * zt + cos(q(5)) * cos(qt2) * cos(q(3)) * cos(q(2)) * cos(q(1)) * zt - cos(q(5)) * cos(qt2) * sin(q(3)) * sin(q(2)) * cos(q(1)) * zt - cos(q(5)) * sin(qt2) * cos(q(3)) * cos(q(2)) * cos(q(1)) * yt + cos(q(5)) * sin(qt2) * sin(q(3)) * sin(q(2)) * cos(q(1)) * yt -0.135e0 * sin(q(1)) * sin(q(2)) * sin(q(3)) * cos(q(5)) + 0.135e0 * sin(q(1)) * cos(q(2)) * cos(q(3)) * cos(q(5)) - 0.960e0 * sin(q(1)) * sin(q(2)) * sin(q(3)) + 0.175e0 * sin(q(1)) * sin(q(2)) * cos(q(3)) + 0.960e0 * sin(q(1)) * cos(q(2)) * cos(q(3)) + 0.175e0 * sin(q(1)) * cos(q(2)) * sin(q(3)) - sin(q(1)) * sin(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * yt - sin(q(1)) * sin(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * yt - sin(q(1)) * sin(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * zt - sin(q(1)) * sin(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * zt + sin(q(1)) * sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * yt - sin(q(1)) * sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * yt + sin(q(1)) * sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * zt - sin(q(1)) * sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * zt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * cos(q(3)) * sin(q(2)) * xt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * sin(q(3)) * cos(q(2)) * xt + sin(q(1)) * cos(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * yt + sin(q(1)) * cos(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * yt + sin(q(1)) * cos(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * zt + sin(q(1)) * cos(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * zt + sin(q(1)) * sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * yt - sin(q(1)) * sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * yt + sin(q(1)) * sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * zt - sin(q(1)) * sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * zt - sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * cos(q(3)) * sin(q(2)) * xt - sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * sin(q(3)) * cos(q(2)) * xt - cos(q(4)) * sin(q(6)) * cos(qt2) * sin(qt1) * cos(q(1)) * yt - cos(q(4)) * sin(q(6)) * sin(qt2) * sin(qt1) * cos(q(1)) * zt - cos(q(5)) * sin(q(6)) * sin(qt1) * cos(q(1)) * sin(q(4)) * xt + cos(q(4)) * cos(q(6)) * cos(qt2) * cos(qt1) * cos(q(1)) * yt + cos(q(4)) * cos(q(6)) * sin(qt2) * cos(qt1) * cos(q(1)) * zt + sin(q(1)) * cos(q(5)) * cos(qt2) * cos(q(3)) * cos(q(2)) * zt - sin(q(1)) * cos(q(5)) * cos(qt2) * sin(q(3)) * sin(q(2)) * zt - sin(q(1)) * cos(q(5)) * sin(qt2) * cos(q(3)) * cos(q(2)) * yt + sin(q(1)) * cos(q(5)) * sin(qt2) * sin(q(3)) * sin(q(2)) * yt + cos(q(5)) * cos(q(6)) * cos(qt1) * cos(q(1)) * sin(q(4)) * xt + 0.135e0 * sin(q(5)) * sin(q(4)) * cos(q(1)) - 0.135e0 * sin(q(5)) * cos(q(4)) * cos(q(3)) * sin(q(1)) * sin(q(2)) - 0.135e0 * sin(q(1)) * cos(q(2)) * sin(q(3)) * sin(q(5)) * cos(q(4)) + 0.900e0 * sin(q(1)) * sin(q(2)) + sin(q(5)) * cos(qt2) * cos(q(1)) * sin(q(4)) * zt - sin(q(5)) * sin(qt2) * cos(q(1)) * sin(q(4)) * yt + cos(q(4)) * sin(q(6)) * cos(qt1) * cos(q(1)) * xt + cos(q(4)) * cos(q(6)) * sin(qt1) * cos(q(1)) * xt + sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * yt + sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * yt + sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * zt + sin(q(1)) * cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * zt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * yt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * yt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * zt + sin(q(1)) * cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * zt - sin(q(1)) * sin(q(5)) * sin(q(6)) * sin(qt1) * sin(q(3)) * sin(q(2)) * xt + sin(q(1)) * cos(q(6)) * sin(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * xt + sin(q(1)) * cos(q(6)) * sin(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * xt - cos(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(1)) * sin(q(4)) * yt - cos(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(1)) * sin(q(4)) * zt - sin(q(1)) * sin(q(5)) * cos(q(4)) * cos(qt2) * cos(q(3)) * sin(q(2)) * zt - sin(q(1)) * sin(q(5)) * cos(q(4)) * cos(qt2) * sin(q(3)) * cos(q(2)) * zt + sin(q(1)) * sin(q(5)) * cos(q(4)) * sin(qt2) * cos(q(3)) * sin(q(2)) * yt + sin(q(1)) * sin(q(5)) * cos(q(4)) * sin(qt2) * sin(q(3)) * cos(q(2)) * yt - sin(q(1)) * sin(q(5)) * cos(q(6)) * cos(qt1) * cos(q(3)) * cos(q(2)) * xt + sin(q(1)) * sin(q(5)) * cos(q(6)) * cos(qt1) * sin(q(3)) * sin(q(2)) * xt + sin(q(1)) * sin(q(6)) * cos(qt1) * cos(q(3)) * sin(q(2)) * sin(q(4)) * xt + sin(q(1)) * sin(q(6)) * cos(qt1) * sin(q(3)) * cos(q(2)) * sin(q(4)) * xt - cos(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(1)) * sin(q(4)) * yt - cos(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(1)) * sin(q(4)) * zt + sin(q(1)) * sin(q(5)) * sin(q(6)) * sin(qt1) * cos(q(3)) * cos(q(2)) * xt + 0.175e0 * sin(q(1)) cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * yt - cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * yt + cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * zt - cos(q(5)) * cos(q(4)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * zt + cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * yt - cos(q(5)) * cos(q(4)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * yt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * zt - cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * zt - 0.135e0 * cos(q(2)) * sin(q(3)) * cos(q(5)) - 0.135e0 * sin(q(2)) * cos(q(3)) * cos(q(5)) - sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * yt - sin(q(5)) * cos(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * yt - sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * sin(q(2)) * zt - sin(q(5)) * cos(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * cos(q(2)) * zt - cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * cos(q(3)) * cos(q(2)) * xt + cos(q(5)) * cos(q(4)) * cos(q(6)) * cos(qt1) * sin(q(3)) * sin(q(2)) * xt - sin(q(6)) * cos(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * yt + sin(q(6)) * cos(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * yt - sin(q(6)) * sin(qt2) * sin(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * zt + sin(q(6)) * sin(qt2) * sin(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * zt - sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * yt - sin(q(5)) * sin(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * yt - sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * sin(q(2)) * zt - sin(q(5)) * sin(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * cos(q(2)) * zt + cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * cos(q(3)) * cos(q(2)) * xt - cos(q(5)) * cos(q(4)) * sin(q(6)) * sin(qt1) * sin(q(3)) * sin(q(2)) * xt + cos(q(6)) * cos(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * yt - cos(q(6)) * cos(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * yt + cos(q(6)) * sin(qt2) * cos(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * zt - cos(q(6)) * sin(qt2) * cos(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * zt + 0.175e0 * cos(q(2)) * cos(q(3)) - 0.175e0 * sin(q(2)) * sin(q(3)) - 0.960e0 * cos(q(2)) * sin(q(3)) - 0.960e0 * sin(q(2)) * cos(q(3)) - 0.135e0 * cos(q(2)) * cos(q(3)) * sin(q(5)) * cos(q(4)) + 0.135e0 * sin(q(2)) * sin(q(3)) * sin(q(5)) * cos(q(4)) - cos(q(5)) * cos(qt2) * cos(q(3)) * sin(q(2)) * zt - cos(q(5)) * cos(qt2) * sin(q(3)) * cos(q(2)) * zt + cos(q(5)) * sin(qt2) * cos(q(3)) * sin(q(2)) * yt + cos(q(5)) * sin(qt2) * sin(q(3)) * cos(q(2)) * yt - sin(q(5)) * cos(q(4)) * sin(qt2) * sin(q(3)) * sin(q(2)) * yt + sin(q(5)) * cos(q(6)) * cos(qt1) * cos(q(3)) * sin(q(2)) * xt + sin(q(5)) * cos(q(6)) * cos(qt1) * sin(q(3)) * cos(q(2)) * xt + sin(q(6)) * cos(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * xt - sin(q(6)) * cos(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * xt - sin(q(5)) * sin(q(6)) * sin(qt1) * cos(q(3)) * sin(q(2)) * xt - sin(q(5)) * sin(q(6)) * sin(qt1) * sin(q(3)) * cos(q(2)) * xt + cos(q(6)) * sin(qt1) * cos(q(3)) * cos(q(2)) * sin(q(4)) * xt - cos(q(6)) * sin(qt1) * sin(q(3)) * sin(q(2)) * sin(q(4)) * xt - sin(q(5)) * cos(q(4)) * cos(qt2) * cos(q(3)) * cos(q(2)) * zt + sin(q(5)) * cos(q(4)) * cos(qt2) * sin(q(3)) * sin(q(2)) * zt + sin(q(5)) * cos(q(4)) * sin(qt2) * cos(q(3)) * cos(q(2)) * yt + 0.900e0 * cos(q(2)) + 0.495e0];


%% Kinematic plot of the robot together with local body frames
figure(100)
  plot3([o0(1) o1(1) o2(1) o3(1) o4(1) o5(1) o6(1) o7(1)],...
      [o0(2) o1(2) o2(2) o3(2) o4(2) o5(2) o6(2) o7(2)],... 
      [o0(3) o1(3) o2(3) o3(3) o4(3) o5(3) o6(3) o7(3)],'k.'), hold on


plot3([o0(1) o1(1)], [o0(2) o1(2)], [o0(3) o1(3)],'k-');
plot3([o1(1) o2(1)], [o1(2) o2(2)], [o1(3) o2(3)],'k-');
plot3([o2(1) o3(1)], [o2(2) o3(2)], [o2(3) o3(3)],'k-');
plot3([o3(1) o4(1)], [o3(2) o4(2)], [o3(3) o4(3)],'k-');
plot3([o4(1) o5(1)], [o4(2) o5(2)], [o4(3) o5(3)],'k-');
plot3([o5(1) o6(1)], [o5(2) o6(2)], [o5(3) o6(3)],'k-');
plot3([o6(1) o7(1)], [o6(2) o7(2)], [o6(3) o7(3)],'k-');

axis equal;%, grid on;
xlabel('X[m]'); ylabel('Y [m]'); zlabel('Z [m]');
% view(60,20);
